searchNodes=[{"doc":"HypeLib is the internal Elixir framework of HypeRate which is used across all Elixir related repositories. Examples Prelude The HypeLib library contains a &quot;prelude&quot; module for saving code when it comes to importing frequently used modules. For example would a simple &quot;use&quot; call import TypeCheck and require the Erlang logger. defmodule MyModule do use HypeLib.Prelude # Use TypeCheck for runtime-based type checks # # The `add` function will be wrapped around a special function # which checks if both arguments (a and b) are numbers (an integer or float). # It also checks if the returned value is of type number. @spec! add ( a :: number ( ) , b :: number ( ) ) :: number ( ) def add ( a , b ) , do : a + b end","ref":"HypeLib.html","title":"HypeLib","type":"module"},{"doc":"A utility module for efficiently generating doctest directives Examples The following example defmodule MyModule do @doc &quot;&quot;&quot; A function that calculates the summary of two numbers ## Examples iex&gt; MyModule.add(1, 2) 3 &quot;&quot;&quot; def add ( a , b ) , do : a + b end defmodule MyTest do use HypeLib.DocTester , modules : [ MyModule ] end would result in the following MyTest module: defmodule MyTest do use ExUnit.Case , async : true doctest MyModule end which then can be run by ExUnit. In this example ExUnit would run the add/2 test where the expected result is 3. Expected options Name Expected data type Description modules list(module()) A list of modules to generate the doctest directives for async boolean() Gets passed down to the use ExUnit.Case call Changelog 0.0.1 Initial implementation 2.0.0 Refactor to use a Keyword list as first argument instead of list of modules. Added support for the modules and async option. Added documentation about the expected options.","ref":"HypeLib.DocTester.html","title":"HypeLib.DocTester","type":"module"},{"doc":"The Prelude module contains utility functions for working with external dependencies like TypeCheck, the Elixir Logger moudle etc.","ref":"HypeLib.Prelude.html","title":"HypeLib.Prelude","type":"module"},{"doc":"Imports TypeCheck and requires the Erlang logger","ref":"HypeLib.Prelude.html#core/0","title":"HypeLib.Prelude.core/0","type":"function"},{"doc":"Imports the Ecto schema functions and all changeset functions","ref":"HypeLib.Prelude.html#entity/0","title":"HypeLib.Prelude.entity/0","type":"function"},{"doc":"Imports the Absinthe notation module","ref":"HypeLib.Prelude.html#graphql/0","title":"HypeLib.Prelude.graphql/0","type":"function"},{"doc":"Imports the HypeLib.Utils.String module as StringUtils into the current context. Examples iex&gt; defmodule TokenGenerator do ...&gt; use HypeLib.Prelude , :string ...&gt; ...&gt; @spec! generate_token ( ) :: String . t ( ) ...&gt; def generate_token ( ) do ...&gt; StringUtils.Generator . generate_string! ( 1 , ~w(a) ) ...&gt; end ...&gt; end ...&gt; ...&gt; TokenGenerator . generate_token ( ) &quot;a&quot;","ref":"HypeLib.Prelude.html#string/0","title":"HypeLib.Prelude.string/0","type":"function"},{"doc":"The HypeLib.UseInvoker module offers a use macro for utility modules. The macro defines a __using__ macro in the CALLING MODULE where the first argument is expected to be an atom so we can pass it directly to the apply/3 function as second argument. The macro supports the following options: Name: required_utils Expected data type: list(atom) Description: A list of function names (atoms) which should always be invoked when the macro is called. Examples Without any arguments iex&gt; defmodule MyUtils do ...&gt; use HypeLib.UseInvoker ...&gt; ...&gt; def num ( ) do ...&gt; quote do ...&gt; def add ( a , b ) , do : a + b ...&gt; end ...&gt; end ...&gt; end ...&gt; ...&gt; defmodule MyConsumer do ...&gt; use MyUtils , :num ...&gt; ...&gt; def my_add ( a , b ) , do : add ( a , b ) ...&gt; end ...&gt; ...&gt; MyConsumer . my_add ( 1 , 2 ) 3 With required_utils iex&gt; defmodule MyUtils do ...&gt; use HypeLib.UseInvoker , required_utils : [ :core ] ...&gt; ...&gt; def core do ...&gt; quote do ...&gt; def core_fun ( ) , do : &quot;core function&quot; ...&gt; end ...&gt; end ...&gt; ...&gt; def num ( ) do ...&gt; quote do ...&gt; def add ( a , b ) , do : a + b ...&gt; end ...&gt; end ...&gt; end ...&gt; ...&gt; defmodule MyConsumer do ...&gt; use MyUtils , :num ...&gt; end ...&gt; ...&gt; MyConsumer . core_fun ( ) &quot;core function&quot;","ref":"HypeLib.UseInvoker.html","title":"HypeLib.UseInvoker","type":"module"},{"doc":"Contains utility functions for generating a random string and creating charsets. It offers the following interesting functions: HypeLib.Utils.String.Generator.charset/1 - obtain a charset based on the given name HypeLib.Utils.String.Generator.charsets!/1 - generate one big charset based on the given names HypeLib.Utils.String.Generator.generate_string!/3 - generate a random string based on the given charset The charset/1 function uses the valid_charsets() type for returning a predefined charset.","ref":"HypeLib.Utils.String.Generator.html","title":"HypeLib.Utils.String.Generator","type":"module"},{"doc":"Returns a charset based on the given name Examples Lowercased alphabet iex&gt; HypeLib.Utils.String.Generator . charset ( :lower ) ~w(a b c d e f g h i j k l m n o p q r s t u v w x y z) Uppercased alphabet iex&gt; HypeLib.Utils.String.Generator . charset ( :upper ) ~w(A B C D E F G H I J K L M N O P Q R S T U V W X Y Z) Numerical characters iex&gt; HypeLib.Utils.String.Generator . charset ( :numeric ) ~w(0 1 2 3 4 5 6 7 8 9) Hexadecimal characters iex&gt; HypeLib.Utils.String.Generator . charset ( :hex ) ~w(0 1 2 3 4 5 6 7 8 9 A B C D E F) iex&gt; HypeLib.Utils.String.Generator . charset ( :upper_hex ) ~w(0 1 2 3 4 5 6 7 8 9 A B C D E F) iex&gt; HypeLib.Utils.String.Generator . charset ( :lower_hex ) ~w(0 1 2 3 4 5 6 7 8 9 a b c d e f)","ref":"HypeLib.Utils.String.Generator.html#charset/1","title":"HypeLib.Utils.String.Generator.charset/1","type":"function"},{"doc":"Combines the given charset names to one big charset Examples It should return an error tuple when the given charset names are empty iex&gt; HypeLib.Utils.String.Generator . charsets ( [ ] ) { :error , &quot;Empty charset names list provided&quot; } It should return a combination of the lowercased alphabet and numerical numbers when the charset names are [:lower, :numeric] iex&gt; alias HypeLib.Utils.String.Generator ...&gt; Generator . charsets ( [ :lower , :numeric ] ) { :ok , Generator . charset ( :lower ) ++ Generator . charset ( :numeric ) } It should return an combination of the lower- and uppercased alphabet including numerical characters when the charset names are [:lower, :upper, :numeric] iex&gt; alias HypeLib.Utils.String.Generator ...&gt; Generator . charsets ( [ :lower , :upper , :numeric ] ) { :ok , Generator . charset ( :lower ) ++ Generator . charset ( :upper ) ++ Generator . charset ( :numeric ) }","ref":"HypeLib.Utils.String.Generator.html#charsets/1","title":"HypeLib.Utils.String.Generator.charsets/1","type":"function"},{"doc":"Tries to generate one big charset based on the given charset names. When the charset can't be generated then an error will be raised. This could happen in the following cases: the given list is empty the given list contains invalid charset names (via TypeCheck runtime check) (see Expected arguments section) Expected arguments Name Expected data type Description Example values charset_names list(valid_charsets()) A list of valid charset names [:lower] , ~w(lower upper numeric hex)a Examples iex&gt; HypeLib.Utils.String.Generator . charsets! ( ~w(lower numeric)a ) ~w(a b c d e f g h i j k l m n o p q r s t u v w x y z 0 1 2 3 4 5 6 7 8 9) iex&gt; HypeLib.Utils.String.Generator . charsets! ( [ ] ) ** (RuntimeError) Empty charset names list provided","ref":"HypeLib.Utils.String.Generator.html#charsets!/1","title":"HypeLib.Utils.String.Generator.charsets!/1","type":"function"},{"doc":"","ref":"HypeLib.Utils.String.Generator.html#generate_string/2","title":"HypeLib.Utils.String.Generator.generate_string/2","type":"function"},{"doc":"Generates a string of the desired length with random characters from the given charset. Examples It should return an error when the given charset is empty iex&gt; HypeLib.Utils.String.Generator . generate_string ( 2 , [ ] ) { :error , &quot;Invalid charset length&quot; } Generate a string with a length of 2 and a given charset of ~w(a) iex&gt; HypeLib.Utils.String.Generator . generate_string ( 2 , ~w(a) ) { :ok , &quot;aa&quot; } Generate a random string with a length of 16 and the alphabet given as charset iex&gt; alias HypeLib.Utils.String.Generator ...&gt; { :ok , result } = Generator . generate_string ( 16 , Generator . charset ( :lower ) ) ...&gt; String . length ( result ) 16 It returns the current string if it has already the desired length iex&gt; alias HypeLib.Utils.String.Generator ...&gt; Generator . generate_string ( 1 , Generator . charset ( :lower ) , &quot;a&quot; ) { :ok , &quot;a&quot; } It returns the current string if it is already longer than the desired length iex&gt; alias HypeLib.Utils.String.Generator ...&gt; Generator . generate_string ( 1 , Generator . charset ( :lower ) , &quot;aa&quot; ) { :ok , &quot;aa&quot; }","ref":"HypeLib.Utils.String.Generator.html#generate_string/3","title":"HypeLib.Utils.String.Generator.generate_string/3","type":"function"},{"doc":"","ref":"HypeLib.Utils.String.Generator.html#generate_string!/2","title":"HypeLib.Utils.String.Generator.generate_string!/2","type":"function"},{"doc":"Generates a string of the desired length and given charset. Hint 1: You can use these functions to quickly generate a charset: HypeLib.Utils.String.Generator.charset/1 HypeLib.Utils.String.Generator.charsets!/1 Hint 2: We don't provide any charsets for special characters since this is highly application specific. When the string can't be generated then an error will be raised. This could happen in the following cases: the given charset is an empty list the arguments don't match the expected types (via TypeCheck runtime check) (see Expected arguments section) Expected arguments Name Expected data type Description Example values desired_length number() Only positive numerical values (excluding zero and negative numbers) 0 , 3.14 charset list(String.t()) A list of strings which will be randomly picked [&quot;a&quot;] , ~w(a b c) current_string String.t() The starting string &quot;&quot; , &quot;a&quot; , &quot;aAa&quot; Examples It should raise an runtime error when the charset is an empty list. iex&gt; HypeLib.Utils.String.Generator . generate_string! ( 2 , [ ] ) ** (RuntimeError) Invalid charset length Generate a string with a length of 2 and a given charset of ~w(a) iex&gt; HypeLib.Utils.String.Generator . generate_string! ( 2 , ~w(a) ) &quot;aa&quot; Generate a random string with a length of 16 and the alphabet given as charset iex&gt; alias HypeLib.Utils.String.Generator ...&gt; Generator . generate_string! ( 16 , Generator . charset ( :lower ) ) ...&gt; |&gt; String . length ( ) 16 It returns the current string if it has already the desired length iex&gt; alias HypeLib.Utils.String.Generator ...&gt; Generator . generate_string! ( 1 , Generator . charset ( :lower ) , &quot;a&quot; ) &quot;a&quot; It returns the current string if it is already longer than the desired length iex&gt; alias HypeLib.Utils.String.Generator ...&gt; Generator . generate_string! ( 1 , Generator . charset ( :lower ) , &quot;aa&quot; ) &quot;aa&quot;","ref":"HypeLib.Utils.String.Generator.html#generate_string!/3","title":"HypeLib.Utils.String.Generator.generate_string!/3","type":"function"},{"doc":"Defines the union type of known charset names. Charset name (atom) Description :lower The lowercased alphabet (a-z) :upper The uppercased alphabet (A-Z) :numeric All numerical values (0-9) :hex All hexadecimal values in uppercase (0-F) :lower_hex All hexadecimal values in lowercase (0-f) :upper_hex All hexadecimal values in uppercase (0-F) (This type is managed by TypeCheck , which allows checking values against the type at runtime.) Full definition: valid_charsets ( ) :: :lower | :upper | :numeric | :hex | :lower_hex | :upper_hex","ref":"HypeLib.Utils.String.Generator.html#t:valid_charsets/0","title":"HypeLib.Utils.String.Generator.valid_charsets/0","type":"type"},{"doc":"HypeLib is the internal Elixir framework of HypeRate which is used across all Elixir related repositories.","ref":"readme.html","title":"HypeLib","type":"extras"},{"doc":"def deps do [ { :hype_lib , &quot;~&gt; 2.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/hype_lib .","ref":"readme.html#installation","title":"HypeLib - Installation","type":"extras"}]